function [gatesignal] = moduleselector_normal(voltvector)
%function y = fcn(voltvector)
%#codegen
%test=voltvector
armcount=(max(size(voltvector))-1); %Determines the number of modules in an arm.
modulesOFF=voltvector(1,2); %Determines number of modules in arm to have zero voltage (SC)
gatesignal=ones(armcount+1,1);

if modulesOFF==armcount
    for i=1:armcount
        gatesignal(i)=-1;
    end
    switched=1;
elseif modulesOFF==0
    switched=1;
else
    voltages=zeros(armcount,2);   
    for i=1:armcount  %Creates a vector with all SM capacitor voltages and indexed units
        voltages(i,1)=voltvector(i+1);
        voltages(i,2)=i;
    end
    [~,index]=sort(voltages, 1, 'ascend');
    switched=0;
end

if switched==1
elseif (voltvector(1,1)==1) %If current is positive (capacitors charging)
    for i=(armcount-modulesOFF+1):(armcount)
        gatesignal(voltages(index(i,1), 2))= -1; 
    end
elseif (voltvector(1,1)==-1) %If current is negative (capacitors discharging)
    for i=1:(modulesOFF)
        gatesignal(voltages(index(i,1), 2))= -1;
    end
end

end        